unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    IOGroupPanel0: TPanel;
    ioGroupCaption0: TLabel;
    lvttlPinLabel0: TLabel;
    lvttlPinLabel1: TLabel;
    lvttlPaintBox0: TPaintBox;
    lvttlPaintBox1: TPaintBox;
    IOGroupOutputButton0: TSpeedButton;
    IOGroupInputButton0: TSpeedButton;
    lvttlSetButton0: TButton;
    lvttlSetButton1: TButton;
    lvttlClearButton1: TButton;
    lvttlClearButton0: TButton;

    ioGroupPanel1: TPanel;
    ioGroupCaption1: TLabel;
    lvttlPinLabel2: TLabel;
    lvttlPinLabel3: TLabel;
    lvttlPaintBox2: TPaintBox;
    lvttlPaintBox3: TPaintBox;
    IOGroupInputButton1: TSpeedButton;
    IOGroupOutputButton1: TSpeedButton;
    lvttlSetButton2: TButton;
    lvttlSetButton3: TButton;
    lvttlClearButton2: TButton;
    lvttlClearButton3: TButton;

    IsolatedInputPanel: TPanel;
    IsoInABPin0: TLabel;
    IsoInCaption: TLabel;
    IsoInABPin1: TLabel;
    IsoInABPin2: TLabel;
    IsoInABPin3: TLabel;
    IsoInABPin4: TLabel;
    IsoInABPin5: TLabel;
    IsoInABPin6: TLabel;
    IsoInABPin7: TLabel;
    IsoInABPin8: TLabel;
    IsoInABPin9: TLabel;
    IsoInABPin10: TLabel;
    IsoInABPin11: TLabel;
    IsoInABPin12: TLabel;
    IsoInABPin13: TLabel;
    IsoInABPin14: TLabel;
    IsoInABPin15: TLabel;
    IIPaintBox0: TPaintBox;
    IIPaintBox1: TPaintBox;
    IIPaintBox2: TPaintBox;
    IIPaintBox3: TPaintBox;
    IIPaintBox4: TPaintBox;
    IIPaintBox5: TPaintBox;
    IIPaintBox6: TPaintBox;
    IIPaintBox7: TPaintBox;
    IIPaintBox8: TPaintBox;
    IIPaintBox9: TPaintBox;
    IIPaintBox10: TPaintBox;
    IIPaintBox11: TPaintBox;
    IIPaintBox12: TPaintBox;
    IIPaintBox13: TPaintBox;
    IIPaintBox14: TPaintBox;
    IIPaintBox15: TPaintBox;
    InputReadTimer: TTimer;
    procedure lvttlSetButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure InputReadTimerTimer(Sender: TObject);
    procedure IOGroupOutputButtonClick(Sender: TObject);
    procedure lvttlPaintBoxPaint(Sender: TObject);
    procedure IIPaintBoxPaint(Sender: TObject);
    procedure lvttlClearButtonClick(Sender: TObject);
  private
    isolatedBits0to15: Word;
    lvttlBits: Byte;
    procedure bitPaintCore(Sender: TPaintBox; text: String);
    procedure bitPaintOff(Sender: TPaintBox);
    procedure bitPaintOn(Sender: TPaintBox);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  CardIndex: Longword;           // Card Index of device to control/inspect

implementation
uses AIOWDM;
{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
  var
    NumCards,                   // total number of AIOWDM-connected devices found
    DevID,                      // Device ID of the card under inspection
    reserved,                   // useless placeholder
    L: Longword;
    Name: String;
begin
  NumCards := GetNumCards;
  if NumCards < 1 then
    ShowMessage('This mPCIe-II Family sample expects a single mPCIe-II Family device to be installed, but Zero (0) were detected. Check Device Manager for issues.  The sample''s GUI will now open, but will be non-functional.')
  else if NumCards > 1 then
    ShowMessage('This mPCIe-II Family sample expects a single mPCIe-II Family device to be installed, but ' + IntToStr(NumCards) + ' were detected. Using first device.');

  if NumCards > 0 then
    CardIndex := 0 // change to any desired technique to select one from among the detected cards
  else
    CardIndex := $FFFFFFFF; // indicate no card selected / detected for use

  if CardIndex <> -1 then InputReadTimer.Enabled := True;
end;

procedure TForm1.bitPaintCore(Sender: TPaintBox; text:String);
  Var
    x1, y1, x2, y2, x3, y3, cx, cy, tx, ty: Integer;
    ts : TSize;
begin
  y1 := Sender.Canvas.ClipRect.Top    +1;
  x1 := Sender.Canvas.ClipRect.Left   +1;
  x2 := Sender.Canvas.ClipRect.Right  -1;
  y2 := Sender.Canvas.ClipRect.Bottom -1;
  x3 := 8;
  y3 := 8;
  cx := (x2 + x1) div 2;
  cy := (y2 + y1) div 2;
  ts := Sender.Canvas.textextent(text);
  tx := cx - ts.cx div 2 +1;
  ty := cy - ts.cy div 2 -1;
  Sender.Canvas.Pen.Color := clBtnShadow;
  Sender.Canvas.RoundRect( x1, y1, x2, y2, x3, y3 );
  Sender.Canvas.TextOut( tx, ty, text );
end;

procedure TForm1.bitPaintOn(Sender: TPaintBox);
begin
  Sender.Canvas.Brush.Color := clGreen;
  bitPaintCore(Sender, '1');
end;

procedure TForm1.bitPaintOff(Sender: TPaintBox);
begin
  Sender.Canvas.Brush.Color := clNone;
  bitPaintCore(Sender, '0');
end;

procedure TForm1.IIPaintBoxPaint(Sender: TObject);
  var
    isoBitIndex: Byte;
begin
  isoBitIndex := (Sender as TPaintBox).tag;
  if isolatedBits0to15 and (1 shl isoBitIndex) <> 0 then
    bitPaintOn(Sender As TPaintBox)
  else
    bitPaintOff(Sender As TPaintBox);
end;

procedure TForm1.lvttlPaintBoxPaint(Sender: TObject);
  var
    lvttlBitIndex: Byte;
begin
  lvttlBitIndex := (Sender as TPaintBox).tag;
  if lvttlBits and (1 shl lvttlBitIndex) <> 0 then
    bitPaintOn(Sender As TPaintBox)
  else
    bitPaintOff(Sender As TPaintBox);
end;

procedure TForm1.InputReadTimerTimer(Sender: TObject);
begin
  IOGroupPanel0.Invalidate;
  IOGroupPanel1.Invalidate;
  IsolatedInputPanel.Invalidate;
  if CardIndex = $FFFFFFFF then exit;
  isolatedBits0to15 := RelInPort(CardIndex, 0); // read isolated input data registers at +0 [and +1]
  lvttlBits := RelInPortB(CardIndex, 16); // read lvttl data register at +16
end;

procedure TForm1.IOGroupOutputButtonClick(Sender: TObject);
  var
    outsBitMask : Byte;
begin
  if CardIndex = $FFFFFFFF then Exit;
  outsBitMask := 0;
  if IOGroupOutputButton0.Down then outsBitMask := outsBitMask or $01;
  if IOGroupOutputButton1.Down then outsBitMask := outsBitMask or $02;
  
  // configure LVTTL I/O Group 0 & 1 direction register at Offset 17
  // bit x Set (to "1") Configures I/O Group x as an Output port
  //   ex: bit 0 Set makes I/O Group 0 an Output port [LVTTL bits 0 & 1]
  // bit x Clear (to "0") Configures I/O Group x as an Input port
  //   ex: bit 1 Clear makes I/O Group 1 an Input port [LVTTL bits 2 & 3]
  // ex: writing 0x03 to +17 makes both ports Outputs
  // ex: writing 0x01 makes bits 0 & 1 outputs and bits 2 & 3 inputs
  RelOutPortB(CardIndex, 17, outsBitMask);  // configure I/O direction
end;

procedure TForm1.lvttlSetButtonClick(Sender: TObject);
  var
    lvttlData: Word;
    lvttlBitIndex: integer;
    bitmask: byte;
begin
  lvttlBitIndex := (Sender as TButton).Tag;
  bitmask := 1 shl lvttlBitIndex;
  lvttlData := lvttlBits or bitmask;

  if CardIndex = $FFFFFFFF then begin
    lvttlBits := lvttlData; // demo mode reads what you write [even in input state]

    exit;
  end;
  // Write data bits to LVTTL register at offset 10Hex
  // Writing to bits configured as inputs is safe so we don't bother checking
  RelOutPortB(0, 16, lvttlData);  // write lvttl data
end;

procedure TForm1.lvttlClearButtonClick(Sender: TObject);
  var
    lvttlData: Word;
    lvttlBitIndex: integer;
    bitmask: byte;
begin
  lvttlBitIndex := (Sender as TButton).Tag;
  bitmask := not (1 shl lvttlBitIndex);
  lvttlData := lvttlBits and bitmask;

  if CardIndex = $FFFFFFFF then begin
    lvttlBits := lvttlData; // demo mode reads what you write [even in input state]

    exit;
  end;

  // Write data bits to LVTTL register at offset 10Hex
  // Writing to bits configured as inputs is safe so we don't bother checking
  RelOutPortB(0, 16, lvttlData);  // write lvttl data
end;

end.
