Attribute VB_Name = "AIOWDM"
Const WDG_ACTION_IGNORE = 0
Const WDG_ACTION_DISABLE = 1
Const WDG_ACTION_SOFT_RESTART = 2
Const WDG_ACTION_MOSTLY_SOFT_RESTART = 4
Const PCI_WDG_CSM_RATE = 2.08333
Const P104_WDG_CSM_RATE = 2.08333
Const ISA_WDG_CSM_RATE = 0.894886

Public Declare Function GetNumCards Lib "AIOWDM" Alias "VBGetNumCards" () As Long
Public Declare Function QueryCardInfo Lib "AIOWDM" Alias "VBQueryCardInfo" (ByVal CardNum As Long, ByRef pDeviceID As Long, ByRef pBase As Long, ByRef pNameSize As Long, ByVal pName As String) As Long
Public Declare Function QueryBARBase Lib "AIOWDM.dll" Alias "VBQueryBARBase" (ByVal CardNum As Long, ByVal BARIndex As Long, ByRef pBase As Long) As Long
Public Declare Function WaitForIRQ Lib "AIOWDM" Alias "VBWaitForIRQ" (ByVal Cardnum As Long) As Long
Public Declare Function AbortRequest Lib "AIOWDM" Alias "VBAbortRequest" (ByVal Cardnum As Long) As Long
Public Declare Function CloseCard Lib "AIOWDM" Alias "VBCloseCard" (ByVal Cardnum As Long) As Long
Public Declare Function COSWaitForIRQ Lib "AIOWDM" Alias "VBCOSWaitForIRQ" (ByVal Cardnum As Long, ByVal PPIs As Long, ByRef pData As Byte) As Long
Public Declare Function WDGInit Lib "AIOWDM" Alias "VBWDGInit" (ByVal Cardnum As Long) As Long
Public Declare Function WDGHandleIRQ Lib "AIOWDM" Alias "VBWDGHandleIRQ" (ByVal Cardnum As Long, Action As Long) As Long
Public Declare Function WDGSetTimeout Lib "AIOWDM" Alias "VBWDGSetTimeout" (ByVal Cardnum As Long, ByVal Milliseconds As Double, ByVal MHzClockRate As Double) As Double
Public Declare Function WDGPet Lib "AIOWDM" Alias "VBWDGPet" (ByVal Cardnum As Long) As Long
Public Declare Function WDGReadTemp Lib "AIOWDM" Alias "VBWDGReadTemp" (ByVal Cardnum As Long) As Double
Public Declare Function WDGReadStatus Lib "AIOWDM" Alias "VBWDGReadStatus" (ByVal Cardnum As Long) As Long
Public Declare Function WDGStart Lib "AIOWDM" Alias "VBWDGStart" (ByVal Cardnum As Long) As Long
Public Declare Function WDGStop Lib "AIOWDM" Alias "VBWDGStop" (ByVal Cardnum As Long) As Long
Public Declare Function EmergencyReboot Lib "AIOWDM" Alias "VBEmergencyReboot" () As Long
Public Declare Function WDGSetResetDuration Lib "AIOWDM" Alias "VBWDGSetResetDuration" (ByVal Cardnum As Long, ByVal Milliseconds As Double, ByVal MHzClockRate As Double) As Double

'8-bit Relative
Public Declare Function RelInPortB Lib "AIOWDM" Alias "VBRelInPortB" (ByVal Cardnum As Long, ByVal Port As Long) As Integer
Public Declare Function RelOutPortB Lib "AIOWDM" Alias "VBRelOutPortB" (ByVal Cardnum As Long, ByVal Port As Long, ByVal Value As Byte) As Integer
Public Declare Function RelINSB Lib "AIOWDM" Alias "VBRelINSB" (ByVal CardNum As Long, ByVal Offset As Long, ByVal Count As Long, ByRef pBuf As Byte) As Long

'16-bit Relative
Public Declare Function RelInPort Lib "AIOWDM" Alias "VBRelInPort" (ByVal Cardnum As Long, ByVal Port As Long) As Integer
Public Declare Function RelOutPort Lib "AIOWDM" Alias "VBRelOutPort" (ByVal Cardnum As Long, ByVal Port As Long, ByVal Value As Integer) As Integer
Public Declare Function RelINSW Lib "AIOWDM" Alias "VBRelINSW" (ByVal CardNum As Long, ByVal Offset As Long, ByVal Count As Long, ByRef pBuf As Integer) As Long

'32-bit Relative
Public Declare Function RelInPortL Lib "AIOWDM" Alias "VBRelInPortL" (ByVal Cardnum As Long, ByVal Port As Long) As Long
Public Declare Function RelOutPortL Lib "AIOWDM" Alias "VBRelOutPortL" (ByVal Cardnum As Long, ByVal Port As Long, ByVal Value As Long) As Integer
Public Declare Function RelINSL Lib "AIOWDM" Alias "VBRelINSL" (ByVal CardNum As Long, ByVal Offset As Long, ByVal Count As Long, ByRef pBuf As Long) As Long
Public Declare Function RelInPortDWord Lib "AIOWDM" Alias "VBRelInPortDWord" (ByVal Cardnum As Long, ByVal Port As Long) As Long
Public Declare Function RelOutPortDWord Lib "AIOWDM" Alias "VBRelOutPortDWord" (ByVal Cardnum As Long, ByVal Port As Long, ByVal Value As Long) As Integer

'8-bit Absolute
Public Declare Function InPortB Lib "AIOWDM" Alias "VBInPortB" (ByVal Port As Long) As Integer
Public Declare Function OutPortB Lib "AIOWDM" Alias "VBOutPortB" (ByVal Port As Long, ByVal Value As Byte) As Integer
Public Declare Function INSB Lib "AIOWDM" Alias "VBINSB" (Addr As Long, ByVal Count As Long, ByRef pBuf As Byte) As Long

'16-bit Absolute
Public Declare Function InPort Lib "AIOWDM" Alias "VBInPort" (ByVal Port As Long) As Integer
Public Declare Function OutPort Lib "AIOWDM" Alias "VBOutPort" (ByVal Port As Long, ByVal Value As Integer) As Integer
Public Declare Function INSW Lib "AIOWDM" Alias "VBINSW" (Addr As Long, ByVal Count As Long, ByRef pBuf As Integer) As Long

'32-bit Absolute
Public Declare Function InPortL Lib "AIOWDM" Alias "VBInPortL" (ByVal Port As Long) As Long
Public Declare Function OutPortL Lib "AIOWDM" Alias "VBOutPortL" (ByVal Port As Long, ByVal Value As Long) As Integer
Public Declare Function INSL Lib "AIOWDM" Alias "VBINSL" (Addr As Long, ByVal Count As Long, ByRef pBuf As Long) As Long
Public Declare Function InPortDWord Lib "AIOWDM" Alias "VBInPortDWord" (ByVal Port As Long) As Long
Public Declare Function OutPortDWord Lib "AIOWDM" Alias "VBOutPortDWord" (ByVal Port As Long, ByVal Value As Long) As Integer
