Const WDG_ACTION_IGNORE = 0
Const WDG_ACTION_DISABLE = 1
Const WDG_ACTION_SOFT_RESTART = 2
Const WDG_ACTION_MOSTLY_SOFT_RESTART = 4
Const PCI_WDG_CSM_RATE = 2.08333
Const P104_WDG_CSM_RATE = 2.08333
Const ISA_WDG_CSM_RATE = 0.894886

Private Declare Function GetNumCards Lib "AIOWDM" Alias "VBGetNumCards" () As UInt32
Private Declare Function QueryCardInfo Lib "AIOWDM" Alias "VBQueryCardInfo" (ByVal Cardnum As UInt32, ByRef pDeviceID As UInt32, ByRef pBase As UInt32, ByRef pNameSize As UInt32, ByVal pName As String) As UInt32
Private Declare Function QueryBARBase Lib "AIOWDM.dll" Alias "VBQueryBARBase" (ByVal CardNum As UInt32, ByVal BARIndex As UInt32, ByRef pBase As UInt32) As UInt32
Private Declare Function WaitForIRQ Lib "AIOWDM" Alias "VBWaitForIRQ" (ByVal Cardnum As UInt32) As UInt32
Private Declare Function AbortRequest Lib "AIOWDM" Alias "VBAbortRequest" (ByVal Cardnum As UInt32) As UInt32
Private Declare Function CloseCard Lib "AIOWDM" Alias "VBCloseCard" (ByVal Cardnum As UInt32) As UInt32
Private Declare Function COSWaitForIRQ Lib "AIOWDM" Alias "VBCOSWaitForIRQ" (ByVal Cardnum As UInt32, ByVal PPIs As UInt32, ByRef pData As Byte) As UInt32
Private Declare Function WDGInit Lib "AIOWDM" Alias "VBWDGInit" (ByVal Cardnum As UInt32) As UInt32
Private Declare Function WDGHandleIRQ Lib "AIOWDM" Alias "VBWDGHandleIRQ" (ByVal Cardnum As UInt32, Action As UInt32) As UInt32
Private Declare Function WDGSetTimeout Lib "AIOWDM" Alias "VBWDGSetTimeout" (ByVal Cardnum As UInt32, ByVal Milliseconds As Double, ByVal MHzClockRate As Double) As Double
Private Declare Function WDGPet Lib "AIOWDM" Alias "VBWDGPet" (ByVal Cardnum As UInt32) As UInt32
Private Declare Function WDGReadTemp Lib "AIOWDM" Alias "VBWDGReadTemp" (ByVal Cardnum As UInt32) As Double
Private Declare Function WDGReadStatus Lib "AIOWDM" Alias "VBWDGReadStatus" (ByVal Cardnum As UInt32) As UInt32
Private Declare Function WDGStart Lib "AIOWDM" Alias "VBWDGStart" (ByVal Cardnum As UInt32) As UInt32
Private Declare Function WDGStop Lib "AIOWDM" Alias "VBWDGStop" (ByVal Cardnum As UInt32) As UInt32
Private Declare Function EmergencyReboot Lib "AIOWDM" Alias "VBEmergencyReboot" () As UInt32
Private Declare Function WDGSetResetDuration Lib "AIOWDM" Alias "VBWDGSetResetDuration" (ByVal Cardnum As UInt32, ByVal Milliseconds As Double, ByVal MHzClockRate As Double) As Double

'8-bit Relative
Private Declare Function RelInPortB Lib "AIOWDM" Alias "VBRelInPortB" (ByVal Cardnum As UInt32, Port As UInt32) As UInt16
Private Declare Function RelOutPortB Lib "AIOWDM" Alias "VBRelOutPortB" (ByVal Cardnum As UInt32, Port As UInt32, Value As Byte) As UInt16
Private Declare Function RelINSB Lib "AIOWDM" Alias "VBRelINSB" (ByVal CardNum As UInt32, ByVal Offset As UInt32, ByVal Count As UInt32, ByRef pBuf As Byte) As UInt32

'16-bit Relative
Private Declare Function RelInPort Lib "AIOWDM" Alias "VBRelInPort" (ByVal Cardnum As UInt32, Port As UInt32) As UInt16
Private Declare Function RelOutPort Lib "AIOWDM" Alias "VBRelOutPort" (ByVal Cardnum As UInt32, Port As UInt32, Value As UInt16) As UInt16
Private Declare Function RelINSW Lib "AIOWDM" Alias "VBRelINSW" (ByVal CardNum As UInt32, ByVal Offset As UInt32, ByVal Count As UInt32, ByRef pBuf As UInt16) As UInt32

'32-bit Relative
Private Declare Function RelInPortL Lib "AIOWDM" Alias "VBRelInPortL" (ByVal Cardnum As UInt32, Port As UInt32) As UInt32
Private Declare Function RelOutPortL Lib "AIOWDM" Alias "VBRelOutPortL" (ByVal Cardnum As UInt32, Port As UInt32, Value As UInt32) As UInt16
Private Declare Function RelINSL Lib "AIOWDM" Alias "VBRelINSL" (ByVal CardNum As UInt32, ByVal Offset As UInt32, ByVal Count As UInt32, ByRef pBuf As UInt32) As UInt32
Private Declare Function RelInPortDWord Lib "AIOWDM" Alias "VBRelInPortDWord" (ByVal Cardnum As UInt32, Port As UInt32) As UInt32
Private Declare Function RelOutPortDWord Lib "AIOWDM" Alias "VBRelOutPortDWord" (ByVal Cardnum As UInt32, Port As UInt32, Value As UInt32) As UInt16

'8-bit Absolute
Private Declare Function InPortB Lib "AIOWDM" Alias "VBInPortB" (ByVal Port As UInt32) As UInt16
Private Declare Function OutPortB Lib "AIOWDM" Alias "VBOutPortB" (ByVal Port As UInt32, Value As Byte) As UInt16
Private Declare Function INSB Lib "AIOWDM" Alias "VBINSB" (Addr As UInt32, ByVal Count As UInt32, ByRef pBuf As Byte) As UInt32

'16-bit Absolute
Private Declare Function InPort Lib "AIOWDM" Alias "VBInPort" (ByVal Port As UInt32) As UInt16
Private Declare Function OutPort Lib "AIOWDM" Alias "VBOutPort" (ByVal Port As UInt32, Value As UInt16) As UInt16
Private Declare Function INSW Lib "AIOWDM" Alias "VBINSW" (Addr As UInt32, ByVal Count As UInt32, ByRef pBuf As UInt16) As UInt32

'32-bit Absolute
Private Declare Function InPortL Lib "AIOWDM" Alias "VBInPortL" (ByVal Port As UInt32) As UInt32
Private Declare Function OutPortL Lib "AIOWDM" Alias "VBOutPortL" (ByVal Port As UInt32, Value As UInt32) As UInt16
Private Declare Function INSL Lib "AIOWDM" Alias "VBINSL" (Addr As UInt32, ByVal Count As UInt32, ByRef pBuf As UInt32) As UInt32
Private Declare Function InPortDWord Lib "AIOWDM" Alias "VBInPortDWord" (ByVal Port As UInt32) As UInt32
Private Declare Function OutPortDWord Lib "AIOWDM" Alias "VBOutPortDWord" (ByVal Port As UInt32, Value As UInt32) As UInt16
