// SampDlg.h : header file
//

#if !defined(AFX_SAMPDLG_H__B44D8C96_FB7D_4152_BFD1_271AEA09EE18__INCLUDED_)
#define AFX_SAMPDLG_H__B44D8C96_FB7D_4152_BFD1_271AEA09EE18__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

struct TCOSData{
  unsigned char A,B,C;
};

class TIRQThread;

/////////////////////////////////////////////////////////////////////////////
// CSampDlg dialog

class CSampDlg : public CDialog
{
// Construction
public:
	void ReceiveGenIRQ(int CardNum);
	void ReceiveCOSData(int CardNum, TCOSData COSData[]);
	void AddLine(int CardNum, CString Line);
	void UpdateWDGUI(BOOL EnabWdg);
	void UpdateCOSUI();
    struct TCardData {
      unsigned long  Base;
      unsigned long  PPIs;
      bool           IsWDG;
      unsigned long  IRQCount;
      TCOSData   LastCOSData[10];
      CString         Log;
      unsigned long  WDGPets;
	};
	TCardData CardData[10];
	int WDGCardNum;
	void UpdateButtonUI();
	void UpdateAbortUI();
	CSampDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CSampDlg)
	enum { IDD = IDD_SAMP_DIALOG };
	CEdit	m_TEST;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSampDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

public:
    bool ThereCanBeOnlyOne;
	unsigned int WDGPetTimer;
	unsigned int WDGWaitTimer;
	void OnStopTimer();

	TIRQThread* Thrd;  
    CMutex m_mutex;
		
// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CSampDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSelchangeCardCombo();
	afx_msg void OnGenIRQ();
	afx_msg void OnAbort();
	afx_msg void OnClose();
	afx_msg void OnCos();
	afx_msg void OnWdgIrq();
	afx_msg void OnWdgTst();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnWdgCan();
	afx_msg void OnReadtemp();
	afx_msg void OnReadstatus();
	afx_msg void OnReboot();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SAMPDLG_H__B44D8C96_FB7D_4152_BFD1_271AEA09EE18__INCLUDED_)
